﻿using Infragistics.Controls.Grids;
using System.Windows;

namespace WpfApplication1
{
    /// <summary>
    /// Interaction logic for MainWindow.xaml
    /// </summary>
    public partial class MainWindow : Window
    {
        public MainWindow()
        {
            InitializeComponent();
        }

        private void xamSpreadsheet1_Pasting(object sender, DataObjectPastingEventArgs e)
        {
            XamSpreadsheet xs = sender as XamSpreadsheet;
            e.FormatToApply = DataFormats.Text; // You may also try value "UnicodeText" or "StringFormat"
        }

        private void xamSpreadsheet1_CommandExecuted(object sender, SpreadsheetCommandExecutedEventArgs e)
        {
            if (e.Command == SpreadsheetCommandType.Paste)
            {
                var ss = (XamSpreadsheet)sender;
                var isValid = AreAllSelectedCellValuesValid(ss);
                if (!isValid) ss.UndoManager.Undo();
            }
        }

        private static bool AreAllSelectedCellValuesValid(XamSpreadsheet ss)
        {
            foreach (var ws in ss.SelectedWorksheets)
            {
                foreach (var cr in ss.ActiveSelection.CellRanges)
                {
                    for (int r = cr.FirstRow; r < cr.LastRow; r++)
                    {
                        var row = ws.Rows[r];

                        for (int c = cr.FirstColumn; c < cr.LastColumn; c++)
                        {
                            if (!row.ValidateCellValue(c)) return false;
                        }
                    }
                }
            }
            return true;
        }
    }
}
